package ru.dbotthepony.kstarbound.world.entities

import ru.dbotthepony.kstarbound.Starbound
import ru.dbotthepony.kstarbound.defs.ActorMovementParameters
import ru.dbotthepony.kstarbound.fromJson
import ru.dbotthepony.kstarbound.util.Either
import ru.dbotthepony.kstarbound.world.World
import ru.dbotthepony.kstarbound.world.physics.Poly

class PlayerEntity(world: World<*, *>) : Entity(world) {
	override val movement = EntityActorMovementController(this)

	init {
		movement.actorMovementParameters = movement.actorMovementParameters.merge(
			Starbound.gson.fromJson("""
			{
    "standingPoly" : [ [-0.75, -2.0], [-0.35, -2.5], [0.35, -2.5], [0.75, -2.0], [0.75, 0.65], [0.35, 1.22], [-0.35, 1.22], [-0.75, 0.65] ],
    "crouchingPoly" : [ [-0.75, -2.0], [-0.35, -2.5], [0.35, -2.5], [0.75, -2.0], [0.75, -1], [0.35, -0.5], [-0.35, -0.5], [-0.75, -1] ],
    "mass" : 1.6,

    // should keep the player from teleporting through walls
    "maximumCorrection" : 3,
    "maxMovementPerStep" : 0.4,

    "liquidFriction" : 13.0,
    "normalGroundFriction" : 35.0,

    "groundForce" : 250.0,
    "airForce" : 50.0,
    "liquidForce" : 80.0
  }
		""".trimIndent(), ActorMovementParameters::class.java)
		).merge(Starbound.gson.fromJson("""
			{
    "flySpeed" : 0,
    "airFriction" : 0.5,
    "airJumpProfile" : {
      "jumpSpeed" : 23.0,
      "jumpInitialPercentage" : 0.75,
      "jumpHoldTime" : 0.2
    }
  }
		""".trimIndent(), ActorMovementParameters::class.java))
	}
}
